' Description: Script for downloading a file from URL to the given directory on NW server
' Date: Nov. 2001
' Usage: Tool for Transfering files to Remote server
' NSNINIT (run just once for starting the scripting machine)
' NSN getftp URL Path
'


Sub Main

'***** This module makes public variables that will be used throughout the program *****
'***** As well as calling modules in order to set the flags for the program *************

	public vGetExt 			'Holds the extinsion of the file needed w/out it's full name
	public vGetFile 		'Holds the name of the file needed for ftp w/out extension
	public vFTPSrvr 		'holds the name of remote host where needed file resides
	public vFTPPath 		'Holds Path to remote host w/out servername and filename
	public vURL			'Path to directory on remote host where file lives
	public vPath 			'Path to directory on local machine to save file to 
	public vFileName 		'Used to hold the file Name of the file to Transfer
	public vSavepath 		'The path on the local machine for FTP file
	public vFileCnt 		'Keeps a count on the number of files transfered
	public vExists			'holds True or False depending on whether or not file exists locally	
	public FSO			'Used to hold the (UCX) file system Object
	public Textstream		'Variable used to write to the log file
	public entries 			'the collection of files (& directories) on the remote server
	public vRetryCnt		'variable used it calculateing the number of retries to attempt
	public ftpmgr			'Used to hold the (UCX) file transfer protocol object
	public vRetryNum		'A constant holding the number of retries to attempt (3)
	public vLogedOn			'Flag that is raised to "Yes" when logged onto the remote server
	public writeVerify		'Variable used in writeing to the log file (When Verified)
	public writeDelete		'Variable used in writeing to the log file (When Remote copy deleted)
	public entry			'variable used to hold an instance of the entries collection
	public vMirrorflag		'flag used in determineing whether or not to mirror said directory

	on error resume next 

	call SetFlags			'Sets the flags to be used in processing
	vMirrorflag = "Up"
	if ArgumentCount > 3 then
		call commands		'Sets more flags to be used in processing
	end if

	call MainLineRtn		'Calls MainLineRtn to begin processing

end sub

'************************************* sub MainLineRtn *****************************************************

sub MainLineRtn                '********** main line routine --- controls the flow of the program *********
			       '************** --- vFatalFlag is used to escape prog. incase of major error

	on error resume next
	
	if vFatalFlag <> "Up" then
	         call OpenLogs
	end if
	if vFatalFlag <> "Up" then
	         call CheckArgs
	end if
	if vFatalFlag <> "Up" then
	         call Login
	end if
	if vFatalFlag <> "Up" then
	         call CheckFilename
	end if
	if vFatalFlag <> "Up" then
		if vMirrorFlag = "UP" then
			call MirrorDir
		end if
	end if
	if vFatalFlag <> "Up" then
	         call PerformFTP
	end if
	if vFatalFlag <> "Up" then
	         call Finish
	end if
	if vFatalFlag <> "Up" then
        	call exitprog
	end if

end sub

'************************************** Sub SetFlags ******************************************************************

sub SetFlags		'****** This Module sets the initial flags used in processing

	vFatalFlag = "Down"
	vExistsFlag = "Down"
	vVerifyFlag = "Down"
	vDeleteRemFlag = "Down"
	vExists = "False"
	vRetryCnt = 1
	vFileCnt = 0
	vLogedOn = "NO"
	vRetryNum = 1
	writeDelete = " "
	writeVerify = " "
	vMirrorflag = "Down"

end sub

'************************************** Sub OpenLogs ******************************************************************

sub OpenLogs		'***** Opens a TextStream file to be used as a LOG file and prints initial setup
			'********** Also will create a file called FTP-ERR-LOG.txt & BackupFTPlog.txt if nonexistant

	on error resume next

	set FSO = createObject("Scripting.filesystemObject")
	set TextStream = FSO.OpenTextFile("Sys:\etc\FTP.log", 8, true, -1)
	TextStream.close
	
	set FSO = createObject("Scripting.filesystemObject")
	set TextStream = FSO.OpenTextFile("Sys:\etc\BackupFTP.log", 8, true, -1)
	TextStream.close
	
	set FSO = createObject("Scripting.filesystemObject")

    do while vRetryCnt > 0
	Set file = FSO.GetFile("Sys:\etc\FTP.log")
	If (err.number <> 0) then
	    if vRetryCnt > 1 then
		vRetryCnt = vRetryCnt - 1
	    else
		print ("ERROR: Could not Create Log File")
		Print ("******** TRANSACTION CANCELED **********")
		TextStream.writeline ("ERR:" & Date & Time & " Could'nt Create Log File"  & vURL & " ->" & vPath) 
		vFatalFlag = "Up"
		wait 5000
		call exitprog
		exit sub
	    end if
	else
		vRetryCnt = 0
	end if  
     loop

	vRetryCnt = vRetryNum
 
'*** Creates a backup log file called BackupFTP.log if the FTPget.log file reaches over 1000 bytes
'******* This is done by deleteing the backup file and renameing the log file, BackupFTP.log***********

	print (file.size & "= file size")
	if file.size > 100000 then
	
		Set delFile =  FSO.GetFile("Sys:\etc\BackupFTP.log") 
		delFile.Delete (TRUE) 
		file.name = "BackupFTP.log"
		set FSO = createObject("Scripting.filesystemObject")
		set TextStream = FSO.OpenTextFile("Sys:\etc\FTP.log", 8, true, -1)
		TextStream.close
		set FSO = createObject("Scripting.filesystemObject")
		
		Set file = FSO.GetFile("Sys:\etc\FTP.log")
			If (err.number <> 0) then
			    if vRetryCnt > 0 then
				vRetryCnt = vRetryCnt - 1
			
			    end if
				print ("ERROR: Could not Create Log File")
				Print ("******** TRANSACTION CANCELED **********")
				TextStream.writeline ("ERR:" & Date & " " & Time & " Could'nt Find Log File"  & vURL & " ->" & vPath) 
                 		vFatalFlag = "Up"
				call exitprog				'right here
				exit sub
			end if  
		
		set TextStream = file.OpenAsTextStream(8)
	else
		set TextStream = file.OpenAsTextStream(8)
	end if


end sub

'************************************** Sub CheckArgs ******************************************************************

sub CheckArgs		'******* Checks to make sure that the correct number of arguments are passed in ****************

	dim vURLParts		'array used to hold the parts of the path to FTP file

	on error resume next

     If (ArgumentCount < 3) Then	'Makes sure three arguments are passed into the prog.
        Print
   	Print "ERROR: Insufficient number of parameters"
	Print
	Print "The parameters should appear as follows:"
	Print
	Print "Example:  Sys:WcardFTP txdot-hq45/Temp/myfile.txt SYS:\Temp"
	Print "               ^          ^       ^        ^         ^" 
	Print "               l          l       l        l         l" 
	Print "        Program Name ServerName/Directory/File.ext SaveToPath"
	wait 5000
	TextStream.writeline ("ERR:" & Date & Time & " Insufficient # of Parameters"  & vURL & " ->" & vPath) 
        TextStream.close
	vFatalFlag = "Up"
        Exit Sub
     End If
       
               
        vFTPSrvr=""				 	'Initial value - empty string
	vFTPPath=""				 	'Initial value - empty string
	vURL =  Arguments(2)   				'First parameter is URL
	vPath = Arguments(3)				'Second parameter - path for file to save
        	if (err.number <> 0) then
		TextStream.writeline ("ERR:" & Date & Time & " No URL and/or Save Path found "  & vURL & " ->" & vPath) 
        	Print "ERROR: No URL and/or Save Path found"
		Print "Exiting FTP Program"
		wait 5000
		vFatalFlag = "Up"
        	call Exitprog
		exit sub
	end if
                
        vURLparts = split(vURL,"/")		 	'Split URL according to "/" char
	vFTPSrvr=vURLparts(0)			 	'URLparts(0) is the FTP server name
 	vFileName=vURLparts(ubound(vURLparts))		'Last part of URL is filename
	if (err.number <> 0)  then			'Error Checking
		TextStream.writeline ("ERR:" & Date & Time & " Failure determining FTP filename "  & vURL & " ->" & vPath) 
 		Print "ERROR: Failure determining FTP filenames"
		Print "Exiting FTP Program"
		vFatalFlag = "Up"
		wait 5000
        	call exitprog
		exit sub
	end if
	
	
	if vFileName = "" then				'checks to make sure the filename is there
		TextStream.writeline ("ERR:" & Date & Time & " Failure determining FTP filename "  & vURL & " ->" & vPath) 
		Print "ERROR: Failure determining FTP filenames"
		Print "Exiting FTP Program"
		vFatalFlag = "Up"
		wait 5000
	       	call exitprog
		exit sub 
	else
		vFileName = Trim(vfilename)			'trims spaces if necessary off the filename	
	end if

	vPath = Replace(vPath, "/", "\")			'Replace eventual chars "/" by "\"

	If (Right(vPath, 1) <> "\") Then 
	    vPath = vPath + "\"
	End If

	if (err.number <> 0) then 	'Error Checking
		TextStream.writeline ("ERR:" & Date & Time & " Failure reconstructing Save path "  & vURL & " ->" & vPath)
 		Print "ERROR: Failure reconstructing Save Path"
		Print "Exiting FTP Program"
		wait 5000
		vFatalFlag = "Up"
        	call exitprog
		exit sub
	end if


        
	 
        for i = 1 to (ubound(vURLparts)-1) step 1
               	 vFTPPath=vFTPPath + "/" + vURLparts(i)	           'Reconstruct FTP path 
        next						           'without servername and filename
	if (err.number <> 0) then			           'Error Checking
		TextStream.writeline ("ERR:" & Date & Time & " Failure reconstructing Save path "  & vURL & " ->" & vPath) 
		Print "ERROR: Failure reconstructing FTP path"
		Print "Exiting FTP Program"
		wait 5000
		vFatalFlag = "Up"
        	call exitprog
		exit sub	
	end if
	
end sub

'************************************** Sub Login ******************************************************************

sub Login

	on error resume next

	dim vLoginID		'Holder of login ID for Remote server
	dim vLoginPWD		'Holder of Login Password for Remote Server
	dim vValue		'Temporary holder of server LoginID and Password
	dim vFile		'A TextStream file used as a Log file

'***** Read the ftp login ID from the SYS:\ETC\FTPLOGIN.ID file ************************ 

    set stream = createobject("ucx:filesystemobject")
    
   	
  do while vRetryCnt > 0
     set vfile = stream.opentextfile("SYS:\ETC\FTPLOGIN.ID")
     If (Err.Number <> 0) Then 
	if vRetryCnt > 1 then
	    vRetryCnt = vRetryCnt - 1
	else			 
          Print "ERROR: Unable to open the ftp login ID file (SYS:\ETC\FTPLOGIN.ID)"
	  Print "Exiting FTP Program"
          TextStream.writeline ("ERR:" & Date & Time & " Unable to open the ftp login ID file "  & vURL & " ->" & vPath) 
          vFatalFlag = "Up"
	  Wait 5000
          call exitprog
	  exit sub
	end if
     else
	vRetryCnt = 0
     End If
  loop

	vRetryCnt = vRetryNum
	
        vValue = vFile.Readline
        vLoginID = vValue
        vValue = vFile.Readline
        vLoginPwd =  vValue
        vFile.Close

'
'************************* Perform the ftp transfer ************************************* 
'
	
       
        
        set ftpmgr = createobject ("ucx:ftpfilemgr")
	ftpmgr.server = vFTPSrvr			'sets the ftp managers server
	
        
    Do while vRetryCnt > 0
        ftpmgr.login (vLoginID, vLoginPwd)		'logs on to the required server
	if (err.number <> 0) then
		if vRetryCnt > 1 then
			vRetryCnt = vRetryCnt - 1	
	    	else			 
		  TextStream.writeline ("ERR:" & Date & " " & Time & " Could not log on to Server "  & vURL & " ->" & vPath) 
		  Print "ERROR:  Could Not Log On to Server"
		  Print "Exiting FTP Program"
        	  vFatalFlag = "Up"
		  Wait 5000
        	  call exitprog
		  exit sub
		end if
	else
		vLogedOn = "YES"
		vRetryCnt = 0
	end if
    loop

	vRetryCnt = vRetryNum		
	
	

    do while vRetryCnt > 0 
        ftpmgr.changeDir (vFTPPath)             'Changes directory to that of requested file
	if (err.number <> 0) then
		if vRetryCnt > 1 then
			vRetryCnt = vRetryCnt - 1
		else			 
		  TextStream.writeline ("ERR:" & Date & " " & Time & " Server Directory not found "  & vURL & " ->" & vPath)      
		  Print "ERROR: Server Directory not found"
		  Print "Exiting FTP Program"
		  vFatalFlag = "Up"
                  wait 5000			
                  call exitprog
		  exit sub
	        end if
	else
		vRetryCnt = 0
	end if
    Loop

	vRetryCnt = vRetryNum

	set currentDir = ftpmgr.currentDir

	set entries = currentDir.getchildren()  'sets the entries to that of requested directory
		
	ftpmgr.BinMode = True

end sub

'************************************** Sub CheckFilename ********************************************

sub CheckFilename		'************** Determines the filenames contents and whether it is legitamite ****
			        '************** By Breaking the filename into its name and extension ***************

	dim fileplusext			'Variable used to hold the filename and extension
	
	on error resume next
	


	filenamelen = len(vfilename)		'gives the length of the file name
	periodpos = instr(1, vfilename, ".")	'gives the position of the "." in the files name


	if periodpos = 1 then		'period is in the first position like .txt makeing it an invalid entry
	   Print "ERROR: Invalid filename to transfer"
	   Print "Exiting FTP Program"
	   TextStream.writeline ("ERR: " & Date & " " &Time & " Invalid Filename to transfer " & vURL & " ->" & vPath)     
           vFatalFlag = "Up"
	   wait 5000
           call exitprog
	   exit sub 	
	end if
	
	if periodpos = filenamelen then	 'assigns "" to the variable for extension
		vgetfile = vfilename
		vgetext = " "
	end if

	if periodpos = 0 then
		vgetfile = vfilename
		vgetext = " "
	else		
		fileplusext() =  split(vfilename, ".")   'Splits the filename into name & extension		
		vgetfile = fileplusext(0)	
		vgetext = fileplusext(1)
	end if


end sub

'******************************** Sub PerformFTP **************************************************************

sub PerformFTP		' This section calls modules based on the filename givein and thenutilizes NSN's ftpmgr 
			' in order to transfer files from a remote host's directory to the chosen directory on 
			' the local machine  --- If a directory is found within the remote directory (aka. wildcards)
			' it is ommited!!

	on error resume next

	vRetryCnt = vRetryNum			'Sets the RetryCnt = to the RetryNum

 	if vfilename = "*.*" then
		call AllWildcards
	end if

	if vgetfile = "*" and vgetext <> "*" then
		call GetSameExt
	end if

	if vgetext = "*" and vgetfile <> "*" then
		call GetSameName
	end if

	if vgetfile <> "*" and vgetext <> "*" then
		call GetSingleFile
	end if

end sub

'******************************** Sub AllWildCards **************************************************************

sub AllWildcards	' **********************  GETS THE ENTIRE DIRECTORY  (for *.* wildcard char.) ***********

	dim vBytesTrans		'Keeps a count on the total Bytes Transfered

	vBytesTrans = 0

          on error resume next	

	  while (entries.hasmoreelements)               'loops through all entries in directory
		set entry = entries.next
		vFilename = Entry.name
	    if entry.directory then
		print (entry.name &" is a directory")   'Omits directories from Transferring
	    else
		if vExistsFlag = "Up" then
			call ifExists
	    end if 

		if vExists = "False" then
			vSavepath = vpath + entry.name
			vBytesTrans = vBytesTrans + entry.size
			entries.Get (entry.name, vSavepath)	'Transfers the requested File
			if err.number <> 0 then			'Error check for Save Path
				TextStream.writeline ("ERR:" & Date & " " & Time & " File or Save Path Is Invalid "  & vURL & " ->" & vPath)     
				Print "***************************         ERROR"
				Print "*****************************          ERROR"
				Print "*******************************           ERROR"
				print "------------------------------->> File or Save Path Is Invalid!!!"
				wait 5000
				vFatalFlag = "Up"
				vLogedOn = "NO"
				call exitprog
				exit sub
			end if
			VFileCnt = VFileCnt + 1
			if vVerifyFlag = "Up" then 
				call Verify
			end if
			if vDeleteRemFlag = "Up" then
				call DeleteRem
			end if
			if writeverify = " Failed Verification (File Corrupt)" then
			    status = "ERR:"
		         else
			    status = "GET:"
		         end if
			TextStream.writeline (status & Date & " " & Time & " " & Entry.size &":Bytes" & " " & vftpsrvr & vftppath & "/"& entry.name & " ->" & vSavePath & writeVerify & WriteDelete)	
			vSavepath = ""
	     else
		TextStream.writeline ("GET:" & Date & " " & Time & " " & "File Already Exists -->" & Vpath & Entry.Name)
		end if
	    end if
	  wend 

end sub

'******************************** Sub GetSameExt **************************************************************

sub GetSameExt		'****************  Get all files in directory with the same file extension ****

	dim vBytesTrans			   'Keeps a count on the total Bytes Transfered

	vBytesTrans = 0

	on error resume next

 	    while (entries.hasmoreelements)                   'loops through all entries in directory
      	          set entry = entries.next
		  vFileName = Entry.name
		if entry.directory then
			print entry.name &" is a directory"   'Omits directories from Transferring
		else
		if Ucase(right(entry.name, 3)) = Ucase(vgetext) then
		     if vExistsFlag = "Up" then
			
			Call ifExists
		     end if
		   if vExists = "False" then
                      vBytesTrans = vBytesTrans + entry.size
		      vSavepath = vpath + entry.name
		      entries.Get (entry.name, vSavepath)      'Transfers the requested File
		   	if err.number <> 0 then		       'Error check for Save Path
				TextStream.writeline ("ERR:" & Date &" " & Time & " File or Save Path Is Invalid "  & vURL & " ->" & vPath)
				Print "***************************         ERROR"
				Print "*****************************          ERROR"
				Print "*******************************           ERROR"
				print "------------------------------->> File or Save or Path Is Invalid!!!"
				wait 5000
				vFatalFlag = "Up"
				vLogedOn = "NO"
				call exitprog
				exit sub
	        	  end if
		      vFileCnt = vFileCnt + 1
		      if vVerifyFlag = "Up" then
		          call Verify
		      end if
		      if vDeleteRemflag = "Up" then
			  call DeleteRem
		      end if
		      if writeverify = " Failed Verification (File Corrupt)" then
			status = "ERR:"
		      else
			status = "GET:"
		      end if
		      TextStream.writeline (status & Date & " " & Time & " " & Entry.size & ":Bytes"&  " " & vftpsrvr & vftppath & "/"& entry.name & " ->" & vPath & writeVerify & WriteDelete)	
		      vSavepath = "" 
		else
		      TextStream.writeline ("GET:" & Date & " " & Time & " " & "File Already Exists -->" & Vpath & Entry.Name)
		end if
		end if
	     end if    
            wend

end sub

'******************************** Sub GetSameName **************************************************************

sub GetSameName		'************ Gets all files in directory with certain name regardless of extension ****

	dim vBytesTrans		'Keeps a count on the total Bytes Transfered

	vBytesTrans = 0

	on error resume next
	
             while (entries.hasmoreelements)                  'loops through all entries in directory
			set entry = entries.next
			 vFileName = Entry.Name
	        entryname = split(entry.name, ".")
		if entry.directory then
			print entry.name &" is a directory"   'Omits directories from Transferring
		else
		   if  Ucase(entryname(0)) = Ucase(vgetfile) then
			if vExistsFlag = "Up" then
			    call ifExists
			end if
		   if vExists = "False" then
			vSavepath = vpath + entry.name       
			VBytesTrans = VBytesTrans + Entry.size
			
			entries.Get (entry.name, vSavepath)    'Transfers the requested File
			if err.number <> 0 then		       'Error check for Save Path
				TextStream.writeline ("ERR:" & Date &" " & Time & " File or Save Path Is Invalid " & vURL & " ->" & vPath) 
				Print "***************************         ERROR"
				Print "*****************************          ERROR"
				Print "*******************************           ERROR"
				print "------------------------------->> File or Save Path Is Invalid!!!"
				wait 5000
				vFatalFlag = "Up"
				vLogedOn = "NO"
				call exitprog
				exit sub
			end if
			vFileCnt = vFileCnt + 1
		        if vVerifyFlag = "Up" then
		             call Verify
		        end if
		        if vDeleteRemflag = "Up" then
			    call DeleteRem
		        end if
			if writeverify = " Failed Verification (File Corrupt)" then
			    status = "ERR:"
		        else
			    status = "GET:"
		        end if
			TextStream.writeline (status & Date & " " & Time & " " & Entry.size & ":Bytes" &" " & vftpsrvr & vftppath & "/"& entry.name & " ->" & vPath & writeVerify & WriteDelete)		
			vSavepath = ""
		   else
			TextStream.writeline ("GET:" & Date & " " & Time & " " & "File Already Exists -->" & Vpath & Entry.Name)
		   end if
	           end if
		end if
	     wend

end sub

'******************************** Sub GetSingleFile **************************************************************

sub GetSingleFile		'********************  gets the single file name and extension   *****************

	dim vBytesTrans			'Keeps a count on the total Bytes Transfered

	vBytesTrans = 0

	on error resume next
'********************** check this out with a delete ***********************************************************

	while (entries.hasmoreelements)
		set entry = entries.next
 		if ucase(entry.name) = ucase(vFileName) then
			print entry.name & vFileName
		if entry.directory then
			print entry.name &" is a directory"   'Omits directories from Transferring
			wait 5000
		else
		   vSavepath = vpath + vfileName
	  	   
		if vExistsFlag = "Up" then
			call ifExists
		end if
		if vExists = "False" then
		   VBytesTrans = Entry.size
		   entries.Get (vFileName, vSavepath)           'Transfers the requested File
		   if err.number <> 0 then			'Error check for Save Path
		 	TextStream.writeline ("ERR:" & Date &" " & Time & " File or Save Path Is Invalid "  & vURL & " ->" & vPath) 
			Print "***************************         ERROR"
			Print "*****************************          ERROR"
			Print "*******************************           ERROR"
			print "------------------------------->> File or Save Path Is Invalid!!!"
			wait 5000
			vFatalFlag = "Up"
			vLogedOn = "NO"
			call exitprog
			exit sub
		   end if
		   vFileCnt = vFileCnt + 1
			writeVerify = " "
		   if vVerifyFlag = "Up" then
		          call Verify
		    end if
			writedelete = " "
		    if vDeleteRemflag = "Up" then
			vFileName = entry.name 
		        call DeleteRem
		    end if
		    if writeverify = " Failed Verification (File Corrupt)" then
			status = "ERR:"
		    else
			status = "GET:"
		    end if
		   TextStream.writeline (Status & Date & " " & Time & " " & Entry.size & ":Bytes" & " " & vftpsrvr & vftppath & "/"& vFileName & " ->" & vSavePath & writeVerify & WriteDelete)	
		   vSavepath = ""
		else
		    TextStream.writeline ("GET:" & Date & " " & Time & " " & "File Already Exists -->" & Vpath & Entry.Name)	
		end if
		end if
		end if
	wend
end sub

'******************************** Sub Finish **************************************************************

sub Finish		'***** Makes sure that a file was transfered then this code **********************
			'***** Writes the final entries to the FTP Log file and closed the Textstream ****	

	
	on error resume next
	
	if vExists = "True" then 		'Done if File already existed locally
		print " "
		print " "
		print "*************** File(s) Already Exist Locally ************************"
		print " "
		print "*************** If Useing Wildcard Char. (*) *************************"
		print "************** Some Files may have transfered ************************"
		print " "
		print "********************** End Transaction *******************************"
		wait 5000
	
	else
	if vFileCnt = O then			'Done if No files were transffered
		TextStream.writeline ("ERR:" & Date & " " & Time & " File not Found "  & vURL & " ->" & vPath) 
		Print "ERROR: File Could not be found on Specified directory"
		Print " "
		print " "
		Print "*********************** Transaction Cancelled *****************************"
		wait 5000
		
	else					'Done when transaction is successful
		print " "
		print " "
		Print " ****************** Transaction Completed Successfully *******************"
		wait 5000
   	       	
        end if
	end if
  
End Sub

'******************************** Sub Commands **************************************************************

sub commands

	on error resume next

	vcommands = Arguments(4)	'Sets vcommands = to the 4th argument passed in from command line
	
	vcommandparts = split(vcommands, "-")		'Splits vcommands based on the "-" character

	num = ubound(vcommandparts)			'Gives you the size of the array
	
	
    for  i = 1 to num step 1				'Repeats the select case statement in order to raise 
							'***** flags depending on the users choices of commands
	
	select case ucase(vcommandparts(i))

	case "E" or "e"
		vExistsflag = "Up"

	case "V" or "v"
		vVerifyflag = "Up"

	case "D" or "d"
		vDeleteRemFlag = "Up"

	case "R" or "r"
		call retry

	case "MIRROR" or "mirror"
		vMirrorflag = "UP"
	case else
		
		print "*************************************************************"
		print " "
		print " ERROR: Invalid Commands "
		print " "
		print " Commands should appear as follows:"
		print " "
		print " ftpget servername/directory/file.name sys:\tmp -e-d-v-r "
		print "   ^        ^          ^         ^        ^          ^"
		print " program  remote    remote      file   path on     commands"
		print "   name   server   directory    name    local   seperated by (-) "
		print " "
		print " Exiting FTP Program -- Please Try Again "
		print " "
		print "**************************************************************"
		vFatalFlag = "Up"
		wait 5000
	end select
    next

end sub

'******************************** Sub ifexists **************************************************************

sub ifexists
	
	set FSO = createObject("Scripting.filesystemObject")     'creates a file system object
	vExists = fso.fileexists(vpath + vFilename)		 'vExists = "True" or "False" depending on 
								 '           whether the file exists locally
	
end sub

'******************************** Sub Retry **************************************************************

sub Retry

        vRetryNum = 4
	vRetryCnt = vRetryNum

end sub

'******************************** Sub deleteRem **************************************************************

sub deleteRem
	
	on error resume next

	writedelete = " Remote File Deleted"

	entries.RemoveElement (vFileName)  
		if err.number <> 0 then
			writedelete = "Remote File is Read Only"
		end if
	
end sub	

'******************************** Sub Exitprog **************************************************************

sub Exitprog

	if vLogedOn = "YES" then
        	ftpmgr.logout()				'Logs off remote the server
	end if

	textstream.close				'closes the textstream

end sub

'******************************** Sub Verify **************************************************************

sub Verify			'***** Verifies the Copy based on file size *****


	on error resume next	

	set verFile = fso.getfile(vSavePath)
	
	if verFile.size = entry.size then
		writeVerify = " Copy Verified"
	else
		writeVerify = " Failed Verification (File Corrupt)"
	end if

end sub

'************************************************************************************************************

sub MirrorDir

		'Creates an exact image of the remote server on to the designated local directory  
	
	on error resume next
	
	vFatalFlag = "Up"

	vSavepath = vpath 

	Set FSO = CreateObject("Scripting.FileSystemObject") 
		Set Folder = FSO.GetFolder ("sys:/tmp") 
		Set Files = Folder.Files 


	files.reset()
	entries.reset()

	do while files.hasmoreelements()
	        set file = files.next
		file.delete
	loop

 	do while (entries.hasmoreelements)                  'loops through all entries in directory
		set entry = entries.next
		vFileName = Entry.Name
	        if entry.directory then
			print entry.name &" is a directory"   'Omits directories from Transferring
		else
			if vExistsFlag = "Up" then
			          call ifExists
	    		end if 
			if vExists = "False" then
			vSavepath = vpath + entry.name       
			VBytesTrans = VBytesTrans + Entry.size
			entries.Get (entry.name, vSavepath)    'Transfers the requested File
			if err.number <> 0 then		       'Error check for Save Path
				TextStream.writeline ("ERR:" & Date & Time & " File or Save Path Is Invalid " & vURL & " ->" & vPath) 
				Print "***************************         ERROR"
				Print "*****************************          ERROR"
				Print "*******************************           ERROR"
				print "------------------------------->> File or Save Path Is Invalid!!!"
				wait 5000
				vFatalFlag = "Up"
				call exitprog
				exit sub
			end if
			vFileCnt = vFileCnt + 1
				if vVerifyFlag = "Up" then 
				call Verify
			end if
			if vDeleteRemFlag = "Up" then
				call DeleteRem
			end if
			if writeverify = " Failed Verification (File Corrupt)" then
			    status = "ERR:"
		         else
			    status = "GET:"
		        end if
		     	   textStream.writeline (Status & Date & " " & Time & " " & Entry.size & ":Bytes" &" " & vftpsrvr & vftppath & "/"& entry.name & " ->" & vSavePath & writeVerify & WriteDelete)		
			   vSavepath = " "
			else
			   TextStream.writeline ("GET:" & Date & " " & Time & " " & "File Already Exists -->" & Vpath & Entry.Name)
		end if
	    end if
	  loop


'*****************************************************************
		
		Print " "
		Print " "
		print "************************** Transaction   Results ****************************"
		wait 1000

	if vFileCnt <> 0 then
		Print "  "
		Print "*************************>>> Directory Mirrored"
		Print "  " 
		wait 3000
		print "************************** Transaction Successful ***************************"
		Wait 5000
	else 
		print " "
		print " "
		print "****************************** NO FILES FOUND *******************************"
		wait 5000
	end if

		call exitprog

end sub
